unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mmsystem,
  uCache;

const _LoadCount=200;

//BitmapCache
type
  TBitmapCache=class(TCache)
  public
    function    Load(ss:TStream; ID:String):TBitmap;
    function    CreateFunction(ss:TStream; size:Integer; const ID:String):TObject; override;
    function    GetMemorySizeFunction(o:TObject):Integer; override;
  end;

//form
type
  TForm1 = class(TForm)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    BitmapCache : TBitmapCache;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TBitmapCache }

function TBitmapCache.CreateFunction(ss: TStream; size: Integer;
  const ID: String): TObject;
var
  a : TBitmap;
begin
  if not(FileExists(ID))then
  begin
    RESULT := nil;
    exit;
  end;

  a := TBitmap.Create;
  a.HandleType := bmDIB;
  a.LoadFromFile(id);
  a.PixelFormat := pf32bit;
  RESULT := a;
end;

function TBitmapCache.GetMemorySizeFunction(o: TObject): Integer;
begin
  RESULT := TBitmap(o).Width * TBitmap(o).Height * 4;
end;

function TBitmapCache.Load(ss: TStream; ID: String): TBitmap;
begin
  RESULT := TBitmap(inherited Load(ss,0,ID));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TimeBeginPeriod(1);
  Randomize;

  BitmapCache := TBitmapCache.Create;
  BitmapCache.SetLimitSize(1024*1024*32);  //32M
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  BitmapCache.Free;

  TimeEndPeriod(1);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  tt : Integer;
  i : Integer;
  f : String;
  bmp : TBitmap;
begin
  tt := TimeGetTime;

  for i:=0 to _LoadCount-1 do
  begin
    f := 'sample'+IntToStr(Random(4))+'.bmp';
    bmp := TBitmap.Create;
    bmp.LoadFromFile(f);
    //bmp.Free;
    BitmapCache.UnLoad(bmp); 
  end;

  //Log
  Memo1.Lines.Add('');
  Memo1.Lines.Add('ʏǍ');
  Memo1.Lines.Add(format('vԁF%d ms',[Integer(TimeGetTime)-tt]));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  tt : Integer;
  i : Integer;
  f : String;
  bmp : TBitmap;
begin
  tt := TimeGetTime;

  for i:=0 to _LoadCount-1 do
  begin
    f := 'sample'+IntToStr(Random(4))+'.bmp';
    bmp := BitmapCache.Load(nil,f);
    BitmapCache.UnLoad(bmp);
  end;

  //Log
  Memo1.Lines.Add('');
  Memo1.Lines.Add('LbVǍ');
  Memo1.Lines.Add(format('vԁF%d ms',[Integer(TimeGetTime)-tt]));
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i : Integer;
  o : TCacheListObject;
begin
  //₷邽߁A\OɋIɃLbVe\[g
  BitmapCache.Update(TRUE);

  Memo1.Lines.Add('');
  Memo1.Lines.Add('LbV');
  Memo1.Lines.Add(format('LbVF%d/%d KB',[BitmapCache.GetCacheSize div 1024,BitmapCache.GetLimitSize div 1024]));
  for i:=0 to BitmapCache.List.Count-1 do
  begin
    o := TCacheListObject(BitmapCache.List.Items[i]);
    Memo1.Lines.Add(format('%16sF%8d KB : %3d HIT : %4d LIFE',[o.ID,o.MemorySize div 1024,o.LoadCount,o.LifeCount]));
  end;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  BitmapCache.ClearnUp;
  Memo1.Lines.Add('');
  Memo1.Lines.Add('LbVNA܂B');
end;

end.
 