unit uCache;

interface

uses SysUtils,Classes;//,uAnsiLowerCase;

//ܖ
const
  _CacheMaxLifeCount = 4096;
  _CacheListCountLimit=512;

//PȂ|C^ƎQƃJE^ێɃNX̂SO鎄
type TCacheListObject = class
  protected

  public
    ID : String;           //LowerCaseꂽID
    IDHash : Integer;      //rpnbVR[h
    //Size : Integer;        //t@CTCY
    MemorySize : Integer;  //ۂ̃̃TCY
    Data : TObject;
    AttachCount : Integer; //QƃJE^Ăǂ́H
    LoadCount : Integer;   //ǂݍ܂ꂽ
    LifeCount : Integer;   //J܂ł̃JE^
    
    constructor Create;
    destructor  Destroy; override;
end;

type TCache = class
  protected
    FLimitSize : Integer;
    FLoadCount : Integer;
    function    GetHash(const s:String):Integer;
    //AnsiLowerCaseOŠꂪς2Byte܂B
    //ƎΉꍇoverrideĂB
    function    CustomAnsiLowerCase(const s:String):String; virtual;
  public
    List : TList;
    Enable : Boolean;

    constructor Create;
    destructor  Destroy; override;
    procedure   Init;
    procedure   Update(ForceSort:Boolean=FALSE);
    procedure   ClearnUp;         //LbV̂Ă
    procedure   SetLimitSize(LimitSize:Integer);
    function    GetTotalSize:Integer;
    function    GetCacheSize:Integer;
    function    GetLimitSize:Integer;
    function    Get(const ID:String; AttachInc:Boolean=TRUE; ResetLife:Boolean=TRUE):TObject;
    function    Load(ss:TStream; size:Integer; const ID:String):TObject;
    function    Add(o:TObject; const ID:String):Boolean;
    function    Serch(const ID:String):Integer;
    procedure   UnLoad(o:TObject);

    function    CreateFunction(ss:TStream; size:Integer; const ID:String):TObject; virtual; abstract;
    function    GetMemorySizeFunction(o:TObject):Integer; virtual; abstract;
end;

type TMemoryStreamCache=class(TCache)
  protected
  public
    function    Load(ss:TStream; ID:String):TMemoryStream;
    function    CreateFunction(ss:TStream; size:Integer; const ID:String):TObject; override;
    function    GetMemorySizeFunction(o:TObject):Integer; override;
end;

type TFileMemoryCache=class(TCache)
  protected
  public
    function    Load(ss:TStream; ID:String):TMemoryStream;
    function    CreateFunction(ss:TStream; size:Integer; const ID:String):TObject; override;
    function    GetMemorySizeFunction(o:TObject):Integer; override;
end;

implementation

function _SortFunc(Item1, Item2: Pointer): Integer;
begin
  //傫
  //LifeCountŃ\[g
  RESULT := -(TCacheListObject(Item1).LifeCount-TCacheListObject(Item2).LifeCount);
end;

{ TCache }

function TCache.Add(o: TObject; const ID: String): Boolean;
var
  n : Integer;
  c : TCacheListObject;
  sID : String;
begin
  RESULT := FALSE;
  n := Serch(ID);
  if (n<>-1)then exit;

  sID := CustomAnsiLowerCase(ID);
  c := TCacheListObject.Create;
  if (Enable)then
    c.ID := sID
  else
    c.ID := sID + IntToStr(FLoadCount);

  c.IDHash := GetHash(c.ID);
  //c.Size := size;
  c.Data := o;
  c.AttachCount := 1;
  c.LoadCount := 1;
  c.MemorySize := GetMemorySizeFunction(o);
  c.LifeCount := _CacheMaxLifeCount;
  List.Add(c);

  Update;  //XV
  
  RESULT := TRUE;
end;

procedure TCache.ClearnUp;
var
  s : Integer;
begin
  s := FLimitSize;
  SetLimitSize(0);
  SetLimitSize(s);
end;

constructor TCache.Create;
begin
  FLimitSize := 0;
  List := TList.Create;
  FLoadCount := 0;
  Enable := TRUE;
  Init;
end;



function TCache.CustomAnsiLowerCase(const s: String): String;
begin
  RESULT := AnsiLowerCase(s);
end;

destructor TCache.Destroy;
begin
  Init;
  List.Free;
  
  inherited;
end;


function TCache.Get(const ID: String; AttachInc:Boolean; ResetLife:Boolean): TObject;
var
  n : Integer;
  c : TCacheListObject;
begin
  n := Serch(ID);
  if (n=-1)then
  begin
    RESULT := nil;
  end
  else
  begin
    c := TCacheListObject(List.Items[n]);
    if (ResetLife)then c.LifeCount := _CacheMaxLifeCount;
    if (ResetLife or AttachInc)then inc(c.LoadCount);
    if (AttachInc)then inc(c.AttachCount);
    RESULT := c.Data;
  end;
end;

function TCache.GetCacheSize: Integer;
var
  i : Integer;
  n : Integer;
begin
  n := 0;
  for i:=0 to List.Count-1 do
    with TCacheListObject(List.Items[i]) do
      if (AttachCount = 0)then n := n + MemorySize;
  RESULT := n;
end;

function TCache.GetHash(const s: String): Integer;
var
  i,l : Integer;
  a : Integer;
begin
  l := Length(s);
  a := 0;
  for i:=1 to l do
    a := a + Integer(s[i]) * (i and $FF);

  RESULT := a;
end;

function TCache.GetLimitSize: Integer;
begin
  RESULT := FLimitSize;
end;

function TCache.GetTotalSize: Integer;
var
  i : Integer;
  n : Integer;
begin
  n := 0;
  for i:=0 to List.Count-1 do
    with TCacheListObject(List.Items[i]) do
      n := n + MemorySize;
  RESULT := n;
end;

procedure TCache.Init;
var
  i : Integer;
begin
  for i:=0 to List.Count-1 do
  begin
    TCacheListObject(List.Items[i]).Free;
  end;
  List.Clear;
end;

function TCache.Load(ss:TStream; size:Integer; const ID:String): TObject;
var
  o : TObject;
  c : TCacheListObject;
  n : Integer;
  sID:String;
begin
  sID := CustomAnsiLowerCase(ID);
  inc(FLoadCount);

  n := Serch(ID);
  if (n<>-1)then
  begin
    c := TCacheListObject(List.Items[n]);
    inc(c.AttachCount);
    inc(c.LoadCount);
    c.LifeCount := _CacheMaxLifeCount;
    if (ss<>nil)then ss.Position := ss.Position + size;
    RESULT := c.Data;
    Exit;
  end;

  //VK
  o := CreateFunction(ss,size,ID);
  if (o<>nil)then
  begin
    Add(o,ID);
    RESULT := o;
  end
  else
    RESULT := nil;
end;

function TCache.Serch(const ID: String): Integer;
var
  i,h : Integer;
  sID : String;
  c : TCacheListObject;
begin
  RESULT:= -1;
  sID := CustomAnsiLowerCase(ID);
  h := GetHash(sID);
  for i:=0 to List.Count-1 do
  begin
    c := TCacheListObject(List.Items[i]);
    if (h=c.IDHash)then
      if (sID = c.ID)then
      begin
        RESULT := i;
        break;
      end;
  end;
end;

procedure TCache.SetLimitSize(LimitSize: Integer);
begin
  FLimitSize := LimitSize;
  UpDate; //XV
end;

procedure TCache.UnLoad(o: TObject);
var
  i : Integer;
  c : TCacheListObject;
begin
  for i:=0 to List.Count-1 do
    if (o = TCacheListObject(List.Items[i]).Data)then
      break;

  //Count0̂ƂAiȂ̂Countɓ
  if ((i=List.Count)or(List.Count=0)) then
  begin
    //Ȃ
    o.Free;
    Exit;
  end;

  //
  c := TCacheListObject(List.Items[i]);
  dec(c.AttachCount);
  if (c.AttachCount < 0)then c.AttachCount := 0;

  Update;  //ŏ߂ĊJ
end;

procedure TCache.Update(ForceSort:Boolean);
var
  i,j,nn : Integer;
  o : TCacheListObject;
begin
  if (List.Count=0)then exit;

  //gpLbV̏ܖi߂
  for i:=0 to List.Count-1 do
    with TCacheListObject(List.Items[i]) do
      if (AttachCount=0)then
        if (LifeCount>0)then dec(LifeCount);

  //ܖ؂
  i := 0;
  While (i<List.Count)do
  begin
    o := TCacheListObject(List.Items[i]);
    if (o.AttachCount=0)then
      if (o.LifeCount=0)then
      begin
        o.Free;
        List.Delete(i);
        continue;
      end;
    inc(i);
  end;

  //~bgI[o[Ȃ
  nn := GetCacheSize;
  if not(ForceSort)then
    if (List.Count<_CacheListCountLimit)then
      if (nn<=FLimitSize)then exit;

  //]Ƀ\[g
  List.Sort(_SortFunc);

  //
  for i:=0 to 255 do //[vȂƂ͎vǈꉞ
  begin
    if (nn<=FLimitSize)then break;
    for j:=List.Count-1 downto 0 do
      with TCacheListObject(List.Items[j]) do
        if (AttachCount=0)then
        begin
          nn := nn - TCacheListObject(List.Items[j]).MemorySize;
          TCacheListObject(List.Items[j]).Free;
          List.Delete(j);
          break;
        end;
  end;

  //őێ𒴂ĂLifeCount0ɂĎE
  if (List.Count<_CacheListCountLimit)then exit;

  nn := List.Count-_CacheListCountLimit;
  for i:=List.Count-1 downto 0 do
    with TCacheListObject(List.Items[i]) do
    begin
      if (nn=0)then break;
      if (AttachCount=0)then
      begin
        LifeCount := 0;
        dec(nn);
      end;
    end;
end;

{ TCacheListObject }

constructor TCacheListObject.Create;
begin
  ID := '';
  //Size := 0;
  Data := nil;
  AttachCount := 0;
  LoadCount := 0;
end;

destructor TCacheListObject.Destroy;
begin
  Data.Free;
  Data := nil;
  
  inherited;
end;

{ TMemoryStreamCache }

function TMemoryStreamCache.CreateFunction(ss: TStream; size: Integer;
  const ID: String): TObject;
var
  a : TmemoryStream;
begin
  a := TmemoryStream.Create;
  a.CopyFrom(ss,0);

  RESULT := a;
end;

function TMemoryStreamCache.GetMemorySizeFunction(o: TObject): Integer;
begin
  RESULT := TMemoryStream(o).Size;
end;

function TMemoryStreamCache.Load(ss: TStream; ID: String): TMemoryStream;
begin
  ss.Position := 0;
  RESULT := TMemoryStream(inherited Load(ss,ss.Size,ID));
end;


{ TFileCache }

function TFileMemoryCache.CreateFunction(ss: TStream; size: Integer;
  const ID: String): TObject;
var
  a : TmemoryStream;
begin
  if not(FileExists(ID))then
  begin
    RESULT := nil;
    exit;
  end;

  a := TmemoryStream.Create;
  a.LoadFromFile(id);
  RESULT := a;
end;

function TFileMemoryCache.GetMemorySizeFunction(o: TObject): Integer;
begin
  RESULT := TMemoryStream(o).Size;
end;

function TFileMemoryCache.Load(ss: TStream; ID: String): TMemoryStream;
begin
  RESULT := TMemoryStream(inherited Load(ss,0,ID));
end;

end.
